#include <assert.h>
#include <ctype.h>
#include <limits.h>
#include <math.h>
#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

char *readline();
char *ltrim(char *);
char *rtrim(char *);
char **split_string(char *);

int parse_int(char *);

/*
 * Complete the 'birthdayCakeCandles' function below.
 *
 * The function is expected to return an INTEGER.
 * The function accepts INTEGER_ARRAY candles as parameter.
 */

int birthdayCakeCandles(int candles_count, int *candles)
{
     int height = candles[0], count = 0;

     for (int i = 0; i < candles_count; i++)
     {
          if (candles[i] > height)
          {
               height = candles[i];
          }
     }

     for (int i = 0; i < candles_count; i++)
     {
          if (candles[i] == height)
          {
               count++;
          }
     }

     return count;
}

int main()
{
     /*Sample input
      4
      3 2 1 3

     *ouput = 2 cuz 3 have the same element
     */
     FILE *fptr = fopen(getenv("OUTPUT_PATH"), "w");

     int candles_count = parse_int(ltrim(rtrim(readline())));

     char **candles_temp = split_string(rtrim(readline()));

     int *candles = malloc(candles_count * sizeof(int));

     for (int i = 0; i < candles_count; i++)
     {
          int candles_item = parse_int(*(candles_temp + i));

          *(candles + i) = candles_item;
     }

     int result = birthdayCakeCandles(candles_count, candles);

     fprintf(fptr, "%d\n", result);

     fclose(fptr);

     return 0;
}

char *readline()
{
     size_t alloc_length = 1024;
     size_t data_length = 0;

     char *data = malloc(alloc_length);

     while (true)
     {
          char *cursor = data + data_length;
          char *line = fgets(cursor, alloc_length - data_length, stdin);

          if (!line)
          {
               break;
          }

          data_length += strlen(cursor);

          if (data_length < alloc_length - 1 || data[data_length - 1] == '\n')
          {
               break;
          }

          alloc_length <<= 1;

          data = realloc(data, alloc_length);

          if (!data)
          {
               data = '\0';

               break;
          }
     }

     if (data[data_length - 1] == '\n')
     {
          data[data_length - 1] = '\0';

          data = realloc(data, data_length);

          if (!data)
          {
               data = '\0';
          }
     }
     else
     {
          data = realloc(data, data_length + 1);

          if (!data)
          {
               data = '\0';
          }
          else
          {
               data[data_length] = '\0';
          }
     }

     return data;
}

char *ltrim(char *str)
{
     if (!str)
     {
          return '\0';
     }

     if (!*str)
     {
          return str;
     }

     while (*str != '\0' && isspace(*str))
     {
          str++;
     }

     return str;
}

char *rtrim(char *str)
{
     if (!str)
     {
          return '\0';
     }

     if (!*str)
     {
          return str;
     }

     char *end = str + strlen(str) - 1;

     while (end >= str && isspace(*end))
     {
          end--;
     }

     *(end + 1) = '\0';

     return str;
}

char **split_string(char *str)
{
     char **splits = NULL;
     char *token = strtok(str, " ");

     int spaces = 0;

     while (token)
     {
          splits = realloc(splits, sizeof(char *) * ++spaces);

          if (!splits)
          {
               return splits;
          }

          splits[spaces - 1] = token;

          token = strtok(NULL, " ");
     }

     return splits;
}

int parse_int(char *str)
{
     char *endptr;
     int value = strtol(str, &endptr, 10);

     if (endptr == str || *endptr != '\0')
     {
          exit(EXIT_FAILURE);
     }

     return value;
}