#include <bits/stdc++.h>

using namespace std;

class SinglyLinkedListNode
{
public:
     int data;
     SinglyLinkedListNode *next;

     SinglyLinkedListNode(int node_data)
     {
          this->data = node_data;
          this->next = nullptr;
     }
};

class SinglyLinkedList
{
public:
     SinglyLinkedListNode *head;
     SinglyLinkedListNode *tail;

     SinglyLinkedList()
     {
          this->head = nullptr;
          this->tail = nullptr;
     }

     void insert_node(int node_data)
     {
          SinglyLinkedListNode *node = new SinglyLinkedListNode(node_data);

          if (!this->head)
          {
               this->head = node;
          }
          else
          {
               this->tail->next = node;
          }

          this->tail = node;
     }
};

void print_singly_linked_list(SinglyLinkedListNode *node, string sep, ofstream &fout)
{
     while (node)
     {
          fout << node->data;

          node = node->next;

          if (node)
          {
               fout << sep;
          }
     }
}

void free_singly_linked_list(SinglyLinkedListNode *node)
{
     while (node)
     {
          SinglyLinkedListNode *temp = node;
          node = node->next;

          free(temp);
     }
}

// Complete the has_cycle function below.

/*
 * For your reference:
 *
 * SinglyLinkedListNode {
 *     int data;
 *     SinglyLinkedListNode* next;
 * };
 *
 */
bool has_cycle(SinglyLinkedListNode *head)
{
     if (head == nullptr)
     {
          return false;
     }

     SinglyLinkedListNode *start = head, *end = head;

     while (end != nullptr && (end->next) != nullptr)
     {
          start = (start->next);
          end = (end->next->next);

          if (start == end)
          {
               return true;
          }
     }
     return false;
}

int main()
{
     ofstream fout(getenv("OUTPUT_PATH"));

     int tests;
     cin >> tests;
     cin.ignore(numeric_limits<streamsize>::max(), '\n');

     for (int tests_itr = 0; tests_itr < tests; tests_itr++)
     {
          int index;
          cin >> index;
          cin.ignore(numeric_limits<streamsize>::max(), '\n');

          SinglyLinkedList *llist = new SinglyLinkedList();

          int llist_count;
          cin >> llist_count;
          cin.ignore(numeric_limits<streamsize>::max(), '\n');

          for (int i = 0; i < llist_count; i++)
          {
               int llist_item;
               cin >> llist_item;
               cin.ignore(numeric_limits<streamsize>::max(), '\n');

               llist->insert_node(llist_item);
          }

          SinglyLinkedListNode *extra = new SinglyLinkedListNode(-1);
          SinglyLinkedListNode *temp = llist->head;

          for (int i = 0; i < llist_count; i++)
          {
               if (i == index)
               {
                    extra = temp;
               }

               if (i != llist_count - 1)
               {
                    temp = temp->next;
               }
          }

          temp->next = extra;

          bool result = has_cycle(llist->head);

          fout << result << "\n";
     }

     fout.close();

     return 0;
}