#include <bits/stdc++.h>

using namespace std;

class SinglyLinkedListNode
{
public:
     int data;
     SinglyLinkedListNode *next;

     SinglyLinkedListNode(int node_data)
     {
          this->data = node_data;
          this->next = nullptr;
     }
};

class SinglyLinkedList
{
public:
     SinglyLinkedListNode *head;
     SinglyLinkedListNode *tail;

     SinglyLinkedList()
     {
          this->head = nullptr;
          this->tail = nullptr;
     }

     void insert_node(int node_data)
     {
          SinglyLinkedListNode *node = new SinglyLinkedListNode(node_data);

          if (!this->head)
          {
               this->head = node;
          }
          else
          {
               this->tail->next = node;
          }

          this->tail = node;
     }
};

void print_singly_linked_list(SinglyLinkedListNode *node, string sep, ofstream &fout)
{
     while (node)
     {
          fout << node->data;

          node = node->next;

          if (node)
          {
               fout << sep;
          }
     }
}

void free_singly_linked_list(SinglyLinkedListNode *node)
{
     while (node)
     {
          SinglyLinkedListNode *temp = node;
          node = node->next;

          free(temp);
     }
}

/*
 * Complete the 'deleteNode' function below.
 *
 * The function is expected to return an INTEGER_SINGLY_LINKED_LIST.
 * The function accepts following parameters:
 *  1. INTEGER_SINGLY_LINKED_LIST llist
 *  2. INTEGER position
 */

/*
 * For your reference:
 *
 * SinglyLinkedListNode {
 *     int data;
 *     SinglyLinkedListNode* next;
 * };
 *
 */

SinglyLinkedListNode *deleteNode(SinglyLinkedListNode *llist, int position)
{
     if (position == 0)
     {
          return llist->next;
     }
     else
     {
          llist->next = deleteNode(llist->next, position - 1);
     }
     return llist;
}

int main()
{
     /*Sample input
       8
       20
       6
       2
       19
       7
       4
       15
       9
       3
     */

     ofstream fout(getenv("OUTPUT_PATH"));

     SinglyLinkedList *llist = new SinglyLinkedList();

     int llist_count;
     cin >> llist_count;
     cin.ignore(numeric_limits<streamsize>::max(), '\n');

     for (int i = 0; i < llist_count; i++)
     {
          int llist_item;
          cin >> llist_item;
          cin.ignore(numeric_limits<streamsize>::max(), '\n');

          llist->insert_node(llist_item);
     }

     int position;
     cin >> position;
     cin.ignore(numeric_limits<streamsize>::max(), '\n');

     SinglyLinkedListNode *llist1 = deleteNode(llist->head, position);

     print_singly_linked_list(llist1, " ", fout);
     fout << "\n";

     free_singly_linked_list(llist1);

     fout.close();

     return 0;
}
