#include <bits/stdc++.h>

using namespace std;

class SinglyLinkedListNode
{
public:
     int data;
     SinglyLinkedListNode *next;

     SinglyLinkedListNode(int node_data)
     {
          this->data = node_data;
          this->next = nullptr;
     }
};

class SinglyLinkedList
{
public:
     SinglyLinkedListNode *head;
     SinglyLinkedListNode *tail;

     SinglyLinkedList()
     {
          this->head = nullptr;
          this->tail = nullptr;
     }

     void insert_node(int node_data)
     {
          SinglyLinkedListNode *node = new SinglyLinkedListNode(node_data);

          if (!this->head)
          {
               this->head = node;
          }
          else
          {
               this->tail->next = node;
          }

          this->tail = node;
     }
};

void print_singly_linked_list(SinglyLinkedListNode *node, string sep, ofstream &fout)
{
     while (node)
     {
          fout << node->data;

          node = node->next;

          if (node)
          {
               fout << sep;
          }
     }
}

void free_singly_linked_list(SinglyLinkedListNode *node)
{
     while (node)
     {
          SinglyLinkedListNode *temp = node;
          node = node->next;

          free(temp);
     }
}

/*
 * Complete the 'getNode' function below.
 *
 * The function is expected to return an INTEGER.
 * The function accepts following parameters:
 *  1. INTEGER_SINGLY_LINKED_LIST llist
 *  2. INTEGER positionFromTail
 */

/*
 * For your reference:
 *
 * SinglyLinkedListNode {
 *     int data;
 *     SinglyLinkedListNode* next;
 * };
 *
 */

int getNode(SinglyLinkedListNode *llist, int positionFromTail)
{
     SinglyLinkedListNode *curr = llist, *result = llist;

     int i = 0;
     while (curr != nullptr)
     {
          curr = (curr->next);
          if (i++ > positionFromTail)
          {
               result = (result->next);
          }
     }

     return (result->data);
}

int main()
{
     /*Sample input
       2
       1
       1
       0
       3
       3
       2
       1
       2
     */

     ofstream fout(getenv("OUTPUT_PATH"));

     int tests;
     cin >> tests;
     cin.ignore(numeric_limits<streamsize>::max(), '\n');

     for (int tests_itr = 0; tests_itr < tests; tests_itr++)
     {
          SinglyLinkedList *llist = new SinglyLinkedList();

          int llist_count;
          cin >> llist_count;
          cin.ignore(numeric_limits<streamsize>::max(), '\n');

          for (int i = 0; i < llist_count; i++)
          {
               int llist_item;
               cin >> llist_item;
               cin.ignore(numeric_limits<streamsize>::max(), '\n');

               llist->insert_node(llist_item);
          }

          int position;
          cin >> position;
          cin.ignore(numeric_limits<streamsize>::max(), '\n');

          int result = getNode(llist->head, position);

          fout << result << "\n";
     }

     fout.close();

     return 0;
}