#include <bits/stdc++.h>

using namespace std;

class SinglyLinkedListNode
{
public:
     int data;
     SinglyLinkedListNode *next;

     SinglyLinkedListNode(int node_data)
     {
          this->data = node_data;
          this->next = nullptr;
     }
};

class SinglyLinkedList
{
public:
     SinglyLinkedListNode *head;
     SinglyLinkedListNode *tail;

     SinglyLinkedList()
     {
          this->head = nullptr;
          this->tail = nullptr;
     }

     void insert_node(int node_data)
     {
          SinglyLinkedListNode *node = new SinglyLinkedListNode(node_data);

          if (!this->head)
          {
               this->head = node;
          }
          else
          {
               this->tail->next = node;
          }

          this->tail = node;
     }
};

void print_singly_linked_list(SinglyLinkedListNode *node, string sep)
{
     while (node)
     {
          cout << node->data;

          node = node->next;

          if (node)
          {
               cout << sep;
          }
     }
}

void free_singly_linked_list(SinglyLinkedListNode *node)
{
     while (node)
     {
          SinglyLinkedListNode *temp = node;
          node = node->next;

          free(temp);
     }
}

/*
 * Complete the 'reversePrint' function below.
 *
 * The function accepts INTEGER_SINGLY_LINKED_LIST llist as parameter.
 */

/*
 * For your reference:
 *
 * SinglyLinkedListNode {
 *     int data;
 *     SinglyLinkedListNode* next;
 * };
 *
 */

void reversePrint(SinglyLinkedListNode *llist)
{
     if (llist == NULL)
     {
          return;
     }
     else
     {
          reversePrint(llist->next);
     }
     std::cout << (llist->data) << std::endl;
}

int main()
{
     /*Sample input
      3
      5
      16
      12
      4
      2
      5
      3
      7
      3
      9
      5
      5
      1
      18
      3
      13
     */

     int tests;
     cin >> tests;
     cin.ignore(numeric_limits<streamsize>::max(), '\n');

     for (int tests_itr = 0; tests_itr < tests; tests_itr++)
     {
          SinglyLinkedList *llist = new SinglyLinkedList();

          int llist_count;
          cin >> llist_count;
          cin.ignore(numeric_limits<streamsize>::max(), '\n');

          for (int i = 0; i < llist_count; i++)
          {
               int llist_item;
               cin >> llist_item;
               cin.ignore(numeric_limits<streamsize>::max(), '\n');

               llist->insert_node(llist_item);
          }

          reversePrint(llist->head);
     }

     return 0;
}
